// TestAC6634Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestAC6634.h"
#include "TestAC6634Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib,"AC6634.lib")
#include"AC6634.h"
HANDLE hDevice;

#include<sys/timeb.h>
#include<math.h>
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestAC6634Dlg dialog

CTestAC6634Dlg::CTestAC6634Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestAC6634Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestAC6634Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestAC6634Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestAC6634Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestAC6634Dlg, CDialog)
	//{{AFX_MSG_MAP(CTestAC6634Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_DI, OnButtonDi)
	ON_BN_CLICKED(IDC_BUTTON_DA, OnButtonDa)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestAC6634Dlg message handlers

BOOL CTestAC6634Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestAC6634Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestAC6634Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestAC6634Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CTestAC6634Dlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	hDevice=AC6634_OpenDevice(0);
	
	if(hDevice==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("error open AC6634 Device!");
		Beep(1000,300);
		exit(0);
	}
	
	return 0;
}

void CTestAC6634Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	AC6634_DO(hDevice,0xaa);
	
}

void CTestAC6634Dlg::OnButtonDi() 
{
	// TODO: Add your control notification handler code here
	CString IO_IN;
	long DIData;

	//IO
	DIData=	AC6634_DI(hDevice);

	//IOתΪʮݣ0x00xffffʾ
	IO_IN.Format("0x%x",DIData);
	
	GetDlgItem(IDC_EDIT_DI)->SetWindowText(IO_IN);

	
	
}

void CTestAC6634Dlg::OnButtonDa() 
{
	// TODO: Add your control notification handler code here

	//struct timeb st,et;
	//double rtime;
	//CString aa;

	//ftime(&st);
	for(int i=0;i<8;i++)
	{
		//AC6634_DO(hDevice,0x1<<i);
		
		AC6634_DA(hDevice,i,4095);//0ͨ20mA

	    Sleep(1000);

	}

	//ftime(&et);

	//rtime=m_passtime(&st,&et);//s

	//aa.Format("%1.2f",rtime);
	
	//GetDlgItem(IDC_EDIT_DI)->SetWindowText(aa);
}


double CTestAC6634Dlg::m_passtime(struct timeb *t1,struct timeb *t2)
{

	int i=0;
	int j=0;
	double a,b;
	
	//st time
	i=(*t1).time;
	j=(*t1).millitm;
	//a=i/1000.0;
	a=i+(double)j/1000.0;
	//et time
    i=(*t2).time;
	j=(*t2).millitm;
	b=i+(double)j/1000.0;
	//b=i/1000.0;
	
    b=b-a;
	
	return b;

}