//AC6634.h wwlab 2005.8.23


//************************************************************************************
//device function
//open device, DeviceNum is number of AC6634 card,=0,1,2...
extern "C" HANDLE __declspec(dllimport) __stdcall AC6634_OpenDevice(long DeviceNum);
//closed device
extern "C" long __declspec(dllimport) __stdcall AC6634_CloseDevice(HANDLE hHandle);

//Set DA
//ch=0-7 via DA output 0-7
//data=0-4095
extern "C" long __declspec(dllimport) __stdcall AC6634_DA(HANDLE hDevice,long ch,long data);

//DIO
extern "C" long __declspec(dllimport) __stdcall AC6634_DI(HANDLE hHandle);
extern "C" long __declspec(dllimport) __stdcall AC6634_DO(HANDLE hHandle, long dodata);



//self testing function and not for USER!!!
extern "C" long __declspec(dllimport) __stdcall AC6634_inb(HANDLE hDevice,long adr);
extern "C" long __declspec(dllimport) __stdcall AC6634_outb(HANDLE hDevice,long adr,long data);

//eeprom r/w
extern "C" long __declspec(dllimport) __stdcall AC6634_EEPROM_CRD(HANDLE hDevice,long adr, long len , long *rdata);
extern "C" long __declspec(dllimport) __stdcall AC6634_EEPROM_CWR(HANDLE hDevice,long adr, long len , long *wdata);

extern "C" long __declspec(dllimport)  __stdcall AC6634_RDCAL(HANDLE hDevice,long *caldata);
extern "C" long __declspec(dllimport)  __stdcall AC6634_WRCAL(HANDLE hDevice, long *caldata);

extern "C" long __declspec(dllimport) __stdcall AC6634_DA_CSET(HANDLE hDevice,long ch,long data);
